package evolvekernel; 

import ec.gp.*; 
import libsvm.*;
/**
 * This is the GPData pluggin for our evolved kernel problem.
 * It has X and Y as two vectors of floats corresponding to 
 * input feature values of any two instances used for dot product 
 * computation.
 * @author udaykamath
 *
 */
public class KernelData extends GPData { 
	public double val; 
	public double val2;
	public svm_node[] x;
	public svm_node[] y;
	public int order;
		
	public KernelData()
		{
		this(0); 
		}
	
	public KernelData(double val)
		{
		this.val = val;
		this.val2 = val;
		x = new svm_node[1]; 
		x[0] = new svm_node();
		y = new svm_node[1]; 
		y[0] = new svm_node();
		this.order = 0;
		}
	
	public GPData copyTo(final GPData gpd)
		{
		KernelData kd = (KernelData)gpd; 
		kd.val = val; 
		kd.val2 = val;
		kd.order = order;
		kd.x = (svm_node[])x.clone(); 
		kd.y = (svm_node[])y.clone();
		return kd; 
		}
}
