package evolvekernel;


import java.io.PrintWriter;

import ec.EvolutionState;
import ec.gp.GPIndividual;
/**
 * This is utility class to print the individuals and kernel tree
 * to output. 
 * @author udaykamath
 *
 */
public class KernelPrinter {
	static PrintWriter pw;
	
	static{
		try{
			pw = new PrintWriter(System.out);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static synchronized void writeFeature(GPIndividual feature, EvolutionState state, long time, double accuracy, int success){
		try{
			pw.print("Feature = ");
			feature.trees[0].printTree(state, pw);
			pw.print(" Accuracy = " + accuracy);
			pw.print(" Time Spent = " + time + " Sucess= ");
			if(success == 0)
				pw.println(1);
			else
				pw.println(-1);
			pw.flush();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
