package evolvekernel; 
import java.util.*; 
import java.io.*; 
import sim.util.*;
import ec.util.*;



public class PartitionData { 
		
	public static void main(String[] args) 
    {
		PartitionData p = new PartitionData(); 
		if (args.length > 1) 
			p.run(args[0], Double.parseDouble(args[1])); 
		else 
			p.run(args[0], 0.60);   
	}

	public void run(String fileName, double percentage)
    {
		String testFilename = fileName + ".test"; 
		String trainFilename = fileName + ".train"; 
		Bag data = new Bag(100); 
		try { 
			BufferedReader inFile = new BufferedReader(new FileReader(new File(fileName))); 
			String line=""; 
			while ((line = inFile.readLine()) != null) 
				data.add(line); 
			
			inFile.close(); 
			
			
			PrintWriter testFile = new PrintWriter(new FileWriter(new File(testFilename))); 
			PrintWriter trainFile = new PrintWriter(new FileWriter(new File(trainFilename))); 
			
			data.shuffle(new MersenneTwisterFast());
			
			int trainSize = (int)(Math.ceil(data.size() * percentage)); 
						
			for (int i=0; i < data.size(); i++) { 
				if (i < trainSize) 
					trainFile.println(data.objs[i]); 
				else 
					testFile.println(data.objs[i]); 
			}
			
			testFile.close(); 
			trainFile.close();
		} catch (IOException e ) {}
	}
}

