package evolvekernel.func; 

import ec.*; 
import ec.gp.*; 
import ec.util.*;
import evolvekernel.*;

public class AddKernel extends GPNode { 
	
	public String toString() { return "+k"; } 
	
	public void checkConstraints(final EvolutionState state,
								 final int tree, 
								 final GPIndividual typicalIndividual,
								 final Parameter individualBase)
	{
		super.checkConstraints(state,tree,typicalIndividual,individualBase); 
		if (children.length!=2) 
			state.output.error("Incorrect number of children for node " + 
							   toStringForError() + " at " + 
							   individualBase); 
	}
	
	public void eval(final EvolutionState state, 
					 final int thread, 
					 final GPData input, 
					 final ADFStack stack, 
					 final GPIndividual individual, 
					 final Problem problem)
	{
		KernelData sd = (KernelData)input; 
		
		children[0].eval(state,thread,input,stack,individual,problem); 
		double t = sd.val;
		
		children[1].eval(state,thread,input,stack,individual,problem);
		sd.val += t; 
	}
}