package evolvekernel.func;

public class FastExp
	{
	static DoubleHashMap map = new DoubleHashMap(10000);
		
		static double memoCount=0; 
		static double noMemoCount=0; 
		
	public static double exp(double val)
		{
		Object o = map.get(val);
		if (o==null) 
			{
			noMemoCount++;
			double d = Math.exp(val);
			if (map.size() < 100000) 
				map.put(val,new Double(d));
			//System.out.println(memoCount / noMemoCount); 

			return d;
			}
		else { 
			memoCount++; 
			//System.out.println(memoCount / noMemoCount); 
			return ((Double)o).doubleValue();
		}
		}
		
	public static void main(String[] args)
		{
		long l = System.currentTimeMillis();
		double d = 0;
		for(int x=0;x<10000000;x++)
			{
			d += Math.exp(4.0);
			}
		System.out.println(System.currentTimeMillis() - l);
		l = System.currentTimeMillis();
		for(int x=0;x<10000000;x++)
			{
			d += FastExp.exp(4.0);
			}
		System.out.println(System.currentTimeMillis() - l);
		}
	}
