package evolvekernel.func; 

import ec.*; 
import ec.gp.*; 
import ec.util.*;
import evolvekernel.*;
import libsvm.*;
/**
 * This is the simplest Linear Kernel. 
 * Kernel Dot Product = dot(X*Y)
 * @author udaykamath
 *
 */
public class Linear extends GPNode { 
	
	public String toString() { return "Linear"; } 
	
	public void checkConstraints(final EvolutionState state,
								 final int tree, 
								 final GPIndividual typicalIndividual,
								 final Parameter individualBase)
	{
		super.checkConstraints(state,tree,typicalIndividual,individualBase); 
		if (children.length!=2) 
			state.output.error("Incorrect number of children for node " + 
							   toStringForError() + " at " + 
							   individualBase); 
	}
	
	public void eval(final EvolutionState state, 
					 final int thread, 
					 final GPData input, 
					 final ADFStack stack, 
					 final GPIndividual individual, 
					 final Problem problem)
	{
		KernelData sd = (KernelData)input; 
		
		children[0].eval(state,thread,input,stack,individual,problem); 
		svm_node[] x1 = sd.x; 
		
		children[1].eval(state,thread,input,stack,individual,problem); 
		svm_node[] x2 = sd.y; 
			
				
		//System.out.println(Functions.dotProduct(x1,x2) + "\t" + power); 
		
		//sd.val = Math.pow(Functions.dotProduct(x1, x2), power); 
		sd.val = Functions.dotProduct(x1, x2);
	}
}
	
