package evolvekernel.func; 

import ec.*; 
import ec.gp.*; 
import ec.util.*; 
import evolvekernel.*; 
import libsvm.*;

public class Y extends GPNode { 
	public String toString() { return "(y)"; } 
	
	public void checkConstraints(final EvolutionState state, final int tree, 
								 final GPIndividual typicalIndividual, 
								 final Parameter individualBase)
	{
		super.checkConstraints(state, tree, typicalIndividual, individualBase); 
		if (children.length!=0) 
			state.output.error("Incorrect number of children for node " + 
							   toStringForError() + " at " + 
							   individualBase); 
	}
	
	public void eval(final EvolutionState state, 
					 final int thread,
					 final GPData input, 
					 final ADFStack stack, 
					 final GPIndividual individual,
					 final Problem problem) 
	{
		KernelData vd = (KernelData)input; 
		//vd.y = Functions.copySVMNode(((SVMEvaluator)problem).y); 
		vd.y = ((SVMEvaluator)problem).threadedEval[thread].y;
	}
}


